/**
 * @file
 * vuo.shader.make.image node implementation.
 *
 * @copyright Copyright © 2012–2013 Kosada Incorporated.
 * This code may be modified and distributed under the terms of the MIT License.
 * For more information, see http://vuo.org/license.
 */

#include "node.h"
#include "VuoGlContext.h"

/// @todo After we drop 10.6 support, switch back to gl3.h.
//#include <OpenGL/gl3.h>
#include <OpenGL/gl.h>


#include<stdio.h>

const char *moduleName = "Shade with Image";
const char *moduleDescription = "Creates a graphics shader that renders objects with an image (ignoring lighting).";
const unsigned int moduleVersion = 100;
const bool nodeIsInterface = false;
const char *moduleKeywords[] = { "draw", "opengl", "glsl", "scenegraph", "graphics", "texture" };
const char *moduleDependencies[] = { "VuoGlContext" };


VuoShader nodeInstanceInit(void)
{
	return VuoShader_makeImageShader();
}

void nodeInstanceEvent
(
		VuoInstanceData(VuoShader) context,
		VuoInputData(VuoImage) image,
		VuoOutputData(VuoShader) shader
)
{
	VuoShader_resetTextures(*context);
	if (image)
		VuoShader_addTexture(*context, image, "texture");

	*shader = *context;
}

void nodeInstanceFini
(
		VuoInstanceData(VuoShader) context
)
{
}
